#!/usr/bin/env python

'''Receive and print events'''
__revision__ = '$Id: event_tail.py 1.18 05/07/28 12:43:35-05:00 zach@fluffhead.mcs.anl.gov $'

from getopt import getopt
from elementtree.ElementTree import Element, tostring
from sss.server import EventReceiver
from sys import argv

class printevent(EventReceiver):
    def __setup__(self):
        data={'c':'**', 'm':'**', 'd':'**'}
        for i in ['component', 'msg', 'data']:
            if self.kwargs.has_key(i):
                data[i] = self.kwargs[i]
        self.__subscriptions__ = [(data['c'], data['m'], data['d'])]
        
    def HandleEvent(self, xe, portinfo):
        '''Print each event'''
        for event in xe.getchildren():
            print tostring(event)
        return Element("event-ok")

if __name__ == '__main__':
    try:
        (opts, args) = getopt(argv[1:], 'dc:m:')
    except:
        print "Usage: event_tail.py -d [-c component] [-m msg] [-i data]"
        raise SystemExit, 1
    debug = len([x for x in opts if x == ('-d', '')])
    component = "**"
    msg = "**"
    data = "**"
    tmp = [x[1] for x in opts if x[0] == '-c']
    if tmp:
        component = tmp[0]
    tmp = [x[1] for x in opts if x[0] == '-m']
    if tmp:
        msg = tmp[0]
    tmp = [x[1] for x in opts if x[0] == '-i']
    if tmp:
        data = tmp[0]
    server = printevent(component=component, msg=msg, data=data, debug=debug)
    server.ServeForever()
