#!/usr/bin/env python

import getopt
import sys
import sss.ssslib
from elementtree.ElementTree import Element, SubElement, tostring

values = {}
for i in ['component','host','port','protocol','schema_version','tier']:
    values[i] = ''

if len(sys.argv) == 1:
    print "Usage: sdremove.py [-d] [-n] [-c component] [-h host] [-p port] [-r protocol] [-s schema_version] [-t tier]"
    sys.exit(1)

try:
    (opts,args) = getopt.getopt(sys.argv[1:],'dnc:h:p:r:s:t:')
except getopt.GetoptError, msg:
    print "Usage: sdremove.py [-d] [-n] [-c component] [-h host] [-p port] [-r protocol] [-s schema_version] [-t tier]"
    print msg

dl = Element("del-location")
loc = SubElement(dl, "location")

for (opt,arg) in opts:
    if opt == '-c':
        SubElement(loc,'component').text= arg
    elif opt == '-h':
        SubElement(loc,'host').text = arg
    elif opt == '-p':
        SubElement(loc,'port').text = arg
    elif opt == '-r':
        SubElement(loc,'protocol').text = arg
    elif opt == '-s':
        SubElement(loc,'schema_version').text = arg
    elif opt == '-t':
        SubELement(loc,'tier').text = arg


for i in ['component','host','port','protocol','schema_version','tier']:
    if not loc.findall(i):
        SubElement( loc, i ,match='false')

xml = tostring(dl)
#print xml

if not ('-n' in sys.argv):
    comm = sss.ssslib.comm_lib(debug=('-d' in sys.argv))
    handle = comm.ClientInit("service-directory")
    comm.SendMessage(handle,xml)
    resp = comm.RecvMessage(handle)
    comm.ClientClose(handle)
    print resp
else:
    print xml
